5da4de0d202188dbe47edd56ebc96a27c5b26ec0
用户原话: 看看 dav 功能,还是不好用,thunderbird 提示这两个地址下没有任何联系人和日程。 关键教训:v31 那个探针(复刻 SyncCalendar 的 DavClient)线上 28/0 全过, 但用户还是空的 —— 因为 Thunderbird 的请求形状不一样:它真正取数据用的是 REPORT(calendar-multiget / addressbook-multiget),而 v31 探针只走 PROPFIND + GET。复刻了 A 客户端全绿,证明不了 B 客户端能看见东西。 三处真根因(都靠新探针 _fb_dav_tb.py 逐步 dump 原始 XML 抓出): ① CardDAV 的 REPORT 回的是草案名 <card:address-data>,而 RFC 6352 规定是 <card:addressbook-data>。Thunderbird 要后者 → 拿到 0 个数据块 → 通讯录永远空。 修:新增 $cardDataXml 闭包,照客户端点名的属性回正文(没点名默认正式名)。 注:第一版写成两个都发 → 正文重复一份、e2e 的 BEGIN:VCARD 计数翻倍,改成按需回。 ② home-set 的 Depth:1 响应里没有集合自身。RFC 4918 要求 PROPFIND 响应必须包含 被请求的资源本身,原来只在非 home 请求时才输出 → PROPFIND /dav/calendars/ 只回子本、没有自己 → 严格客户端判 home 不存在 → 一本都看不见。 修:dav.php / carddav.php 的 home 分支始终先输出集合自身。 ③ 站点根 PROPFIND / 被 Apache 交给 index.php → 302 跳登录页 → Thunderbird 判定 这个域名下没有日历(RFC 6764 允许从域名根发现)。 修:router.php(本地)+ .htaccess / 部署脚本 5c 段独立标记块(线上): RewriteCond 限住 REQUEST_METHOD + RewriteRule ^$ dav.php; 必须限方法,否则 GET / 被 ^$ 吞掉、首页 404(已加反向守卫)。 并让根响应与两个 principal 都给出两套 home-set(calendar + addressbook)。 验证:线上真机 _fb_dav_tb.py 25/0(站点根通 / home-set 含自身 / CardDAV REPORT 真带回 3 个数据块,修复前是 0);逐本 REPORT 所有集合都能取回数据; 旧诊断(SyncCalendar 序列)28/0 无回归;GET / 仍是 302 未被吞。 本地 e2e 1503/0、v33 DAV 反向验证 7/0(三处各自改回旧行为 → 断言全变红); 部署脚本静态断言段本地空跑通过。
FamilyBook
家书,记录家庭的全部生活,一本用岁月写成的家谱。
把一个家的「人」「日子」「去过的地方、看过的电影」收进同一本书里。
它是什么
一个自托管的家庭生活系统。它不是又一个待办清单,而是这个家的长期档案 —— 十年之后还能翻出孩子第一次观影的票根、那年暑假走过的路线。
围绕三个圈展开:
- 人:家庭成员、亲友通讯录,以及他们之间的共享关系
- 时间:日历、日程、提醒,以及任务的期限
- 事件:观影、旅行、其他活动 —— 一切都落在同一条时间轴上
它在做什么
| 阶段 | 主题 | 内容 |
|---|---|---|
| 0 | 地基 | 名册、账号、登录、权限模型、安装向导 |
| 1 | 通信 | 通讯录、共享给某个成员、CardDAV 服务端 |
| 2 | 时间 | 日历本、重复日程、提醒、CalDAV 服务端 |
| 3 | 归一 | 观影与旅行迁入统一事件模型 |
| 4 | 任务 | 任务管理,期限自动映射成日历事件 |
| 5 | 回看 | 统计、年度家书、时间轴 |
当前进度:阶段 0 起步,仓库里只有图标与脚手架。
技术选型
- PHP 7.4+(无框架、无 Composer,上传到站点目录即可运行)
- MySQL 5.7+ / 8.0(
utf8mb4) - 前端为原生 HTML / CSS / JavaScript,无构建步骤
⚠️ 注意 CalDAV / CardDAV 是双向协议,和单纯的 .ics 文件导出不是一个量级的东西。
部署
- 把代码放到站点根目录;
- 复制
config.example.php为config.php,填写数据库与app_key; - 访问站点根,按引导页确认 PHP 版本、扩展、配置、数据库连接四项都通过。
config.php 不入库(已在 .gitignore 中忽略),其中包含数据库口令与加密密钥。
⚠️ app_key 一旦开始记录数据就不能再改(换掉即解不开已有数据),
并且它必须单独备份 —— 密钥丢失等同于数据永久丢失。
隐私
身份证号、手机号属于敏感个人信息,一律加密存储。 (就家庭自用而言,身份证号其实没有多少必须存的场景,启用前请三思。)
图标
见 assets/icons/。概念是「这本书就是家」:屋顶即一本摊开的书,
屋顶下纸做的墙上,三行横线是这个家写下的日子。
开源协议
Languages
PHP
81.6%
JavaScript
9.3%
CSS
9.1%